// light position
float4 vLight;

// vertex transformations world
float4x4 mWorld;
// vertex transformation view/projection
float4x4 mViewProjection;

struct VS_OUTPUT
{
	float4 Pos  : POSITION;
	float2 tc: TEXCOORD0;
	float3 normal: TEXCOORD1;
	float3 light: TEXCOORD2;
	float3 view: TEXCOORD3;
};

VS_OUTPUT main(float3 Pos  : POSITION0, float3 Normal: NORMAL2, float2 tc: TEXCOORD0)
{
	VS_OUTPUT Out;

	// tranform vertex
	float4 pos = mul(float4(Pos, 1), mWorld);
	Out.Pos = mul(pos, mViewProjection);
	Out.light = vLight.xyz - pos.xyz;
	Out.view = float3(0, 0, 1);//   

	float3 normal = mul(float4(Normal, 1), mWorld).xyz;
	normal -= mul(float4(0,0,0, 1), mWorld).xyz;
	Out.normal = normal;

	Out.tc = tc;

	return Out;
}